package dk.brics.xact;

import dk.brics.misc.Origin;

/**
 * Close operation node.
 */
class CloseNode extends OperationNode {

	private final XML self;
	
	/**
	 * Constructs a new close operation node.
	 */
	public CloseNode(XML self, Origin origin) {
		super(origin);
		this.self = self;
	}

	/**
	 * Constructs a new close operation node.
	 */
	public CloseNode(XML self) {
		this(self, null);
	}
	
	/**
	 * Returns the self node.
	 */
	public XML getSelfNode() {
		return self;
	}

	@Override
	void visitAnyBy(AnyNodeVisitor v) {
		v.visit(this);
	}
	
	@Override
	public String toString() {
		return "[CloseNode]";
	}
}
