package dk.brics.xact;

import dk.brics.misc.Origin;

/**
 * Plug multi-value operation node.
 */
class PlugListNode extends PlugNode {
	
	private final Iterable<?> vs;

	/**
	 * Constructs a new plug multi-value node.
	 */
	public PlugListNode(XML self, String gap, Iterable<?> vs, Origin origin) {
		super(self, gap, origin);
		this.vs = vs;
	}
	
	/**
	 * Constructs a new plug multi-value node.
	 */
	public PlugListNode(XML self, String gap, Iterable<?> vs) {
		this(self, gap, vs, null);
	}
	
	/**
	 * Returns the values to be plugged in.
	 */
	public Iterable<?> getValues() {
		return vs;
	}

	@Override
	void visitAnyBy(AnyNodeVisitor v) {
		v.visit(this);
	}
	
	@Override
	public String toString() {
		return "[PlugListNode " + getGap() + "]";
	}
}
