package dk.brics.xact;

import dk.brics.misc.Origin;

/**
 * Plug single-value operation node.
 */
class PlugSingleNode extends PlugNode {

	private final Object v;
	
	/**
	 * Constructs a new plug single-value operation node.
	 */
	public PlugSingleNode(XML self, String gap, Object v, Origin origin) {
		super(self, gap, origin);
		this.v = v;
	}
	
	/**
	 * Constructs a new plug single-value operation node.
	 */
	public PlugSingleNode(XML self, String gap, Object v) {
		this(self, gap, v, null);
	}

	/**
	 * Returns the XML or string value to be plugged in.
	 */
	public Object getValue() {
		return v;
	}

	@Override
	void visitAnyBy(AnyNodeVisitor v) {
		v.visit(this);
	}
	
	@Override
	public String toString() {
		return "[PlugSingleNode " + getGap() + (v instanceof String ? " " + v : "") + "]";
	}
}
