package dk.brics.xact;

import dk.brics.misc.Origin;

/**
 * Exception thrown if XML schema type validation fails.
 */
@SuppressWarnings("serial")
public class XMLValidationException extends XMLException {

	private XMLValidationException next;
	
	/**
	 * Constructs a new exception.
	 */
	public XMLValidationException(String s) {
		super(s);
	}

	/**
	 * Constructs a new exception.
	 */
	public XMLValidationException(String s, Origin origin) {
		super(s, origin);
	}
	
	/**
	 * Constructs a new exception.
	 */
	public XMLValidationException(Throwable cause, Origin origin) {
		super(cause, origin);
	}
	
	/**
	 * Returns the next validation error, or null if none.
	 */
	public XMLValidationException getNext() {
		return next;
	}
	
	/**
	 * Sets the next validation error.
	 */
	public void setNext(XMLValidationException next) {
		this.next = next;
	}
}
