package dk.brics.xact.analysis.flowgraph;

/**
 * A method in an application class with its relevant variables and type annotations.
 */
public class Method {

	private Statement entry;
	
	private Statement exit;
	
	private Variable[] parameters;
	
	private Variable returnVar;
	
	private String name;
	
	private SchemaType returnType;
	
	private SchemaType[] parameterTypes;
	
	public Method(String name, Statement entry, Statement exit, Variable[] parameters, Variable returnVar, SchemaType returnType, SchemaType[] parameterTypes) {
		this.name = name;
		this.entry = entry;
		this.exit = exit;
		this.parameters = parameters;
		this.returnVar = returnVar;
		this.returnType = returnType;
		this.parameterTypes = parameterTypes;
	}
	
	public String getName() {
		return name;
	}
	
	public void setName(String name) {
		this.name = name;
	}
	
	public Statement getEntry() {
		return entry;
	}
	
	public void setEntry(Statement entry) {
		this.entry = entry;
	}
	
	public Statement getExit() {
		return exit;
	}
	
	public void setExit(Statement exit) {
		this.exit = exit;
	}
	
	public Variable getReturnVar() {
		return returnVar;
	}
	
	public void setReturnVar(Variable returnVar) {
		this.returnVar = returnVar;
	}
	
	public Variable getParameter(int i) {
		return parameters[i];
	}
	
	public void setParameter(int i, Variable var) {
		parameters[i] = var;
	}
	
	public Variable[] getParameters() {
		return parameters;
	}
	
	public void setParameters(Variable[] parameters) {
		this.parameters = parameters;
	}
	
	public SchemaType getReturnType() {
		return returnType;
	}
	
	public void setReturnType(SchemaType returnType) {
		this.returnType = returnType;
	}
	
	public SchemaType[] getParameterTypes() {
		return parameterTypes;
	}
	
	public void setParameterTypes(SchemaType[] parameterTypes) {
		this.parameterTypes = parameterTypes;
	}
	
	public SchemaType getParameterType(int i) {
		return parameterTypes[i];
	}
	
	public void setParameterType(int i, SchemaType type) {
		parameterTypes[i] = type;
	}
	
	@Override
	public String toString() {
		return "method " + name;
	}
}
