package dk.brics.xact.analysis.flowgraph.statements;

import dk.brics.misc.Origin;
import dk.brics.xact.analysis.flowgraph.Variable;

public class ArrayReadStm extends Assignment {
	
	private Variable source;
	
	public ArrayReadStm(Variable dest, Variable source, Origin origin) {
		super(dest, origin);
		this.source = source;
	}
	
	@Override
	public String getOpName() {
		return "arrayread";
	}

	@Override
	public void visitBy(StatementVisitor v) {
		v.visitArrayReadStm(this);
	}

	public Variable getSource() {
		return source;
	}

	public void setSource(Variable source) {
		this.source = source;
	}
	
	@Override
	public String toString() {
		return source + "[]" + super.toString();
	}
}
