package dk.brics.xact.analysis.flowgraph.statements;

import dk.brics.misc.Origin;
import dk.brics.xact.analysis.flowgraph.Statement;
import dk.brics.xact.analysis.flowgraph.Variable;

/** 
 * Superclass of abstract statements that are assignments.
 */
public abstract class Assignment extends Statement {

	/** 
	 * The variable being assigned to. 
	 */
	private Variable dest;
	
	/** 
	 * Constructs a new assignment statement.
	 */
	public Assignment(Variable dest, Origin origin) {
		super(origin);
		this.dest = dest;
	}
	
	/**
	 * Returns the destination variable.
	 */
	public Variable getDest() {
		return dest;
	}
	
	/**
	 * Sets the destination variable.
	 */
	public void setDest(Variable dest) {
		this.dest = dest;
	}
	
	@Override
	public String toString() {
		return " => " + dest + " at " + super.toString();
	}	
}
