package dk.brics.xact.analysis.flowgraph.statements;

import dk.brics.misc.Origin;
import dk.brics.xact.analysis.flowgraph.Statement;

/** 
 * No operation.
 */
public class NopStm extends Statement {
	
	private String description; // only used for toString
	
	/** 
	 * Constructs a new <code>NopStm</code> object.
	 */
	public NopStm(Origin origin) {
		this(origin, null);
	}
	
	/** 
	 * Constructs a new <code>NopStm</code> object.
	 */
	public NopStm(Origin origin, String description) {
		super(origin);
		this.description = description;
	}
	
	@Override
	public void visitBy(StatementVisitor v) { 
		v.visitNopStm(this); 
	}
	
	@Override
	public String toString() {
		return "nop" + (description != null ? "[" + description + "]" : "") + " at " + super.toString();
	}	
	
	@Override
	public String getOpName() {
		return "nop";
	}
}
