package dk.brics.xact.analysis.flowgraph.statements;

import dk.brics.misc.Origin;
import dk.brics.xact.analysis.flowgraph.SchemaType;
import dk.brics.xact.analysis.flowgraph.Variable;

/**
 * Assignment of {@link dk.brics.xact.XML#validate(String)}.
 */
public class ValidateStm extends InstanceAssignment {
	
	private SchemaType schema;
	
	private String type;
	
	/**
	 * Constructs a new <code>ValidateStm</code> object.
	 * if <code>base</code> is null, an unknown input value is assumed.
	 */
	public ValidateStm(Variable dest, Variable base, SchemaType schema, Origin origin) {
		super(dest, base, origin);
		this.schema = schema;
		this.type = schema.getType();
	}
	
	/**
	 * Returns the schema.
	 */
	public SchemaType getSchema() {
		return schema;
	}
	
	@Override
	public void visitBy(StatementVisitor v) { 
		v.visitValidateStm(this); 
	}
	
	@Override
	public String toString() {
		return "validate(" + (getBase()!=null ? getBase() + "," : "") + type + ")" + super.toString();
	}
	
	@Override
	public String getOpName() {
		return "validate";
	}
}
