package dk.brics.xact.analysis.flowgraph.statements;

import dk.brics.misc.Origin;
import dk.brics.xact.analysis.flowgraph.Variable;

/** 
 * Assignment of an XML variable.
 */
public class VarStm extends Assignment {
	
	/** 
	 * The variable that is being assigned from. 
	 */
	private Variable source;
	
	/** 
	 * Constructs a new <code>VarStm</code> object.
	 */
	public VarStm(Variable dest, Variable source, Origin origin) {
		super(dest, origin);
		this.source = source;
	}
	
	/**
	 * Returns the source variable.
	 */
	public Variable getSource() {
		return source;
	}
	
	/**
	 * Sets the source variable.
	 */
	public void setSource(Variable source) {
		this.source = source;
	}
	
	@Override
	public void visitBy(StatementVisitor v) { 
		v.visitVarStm(this); 
	}
	
	@Override
	public String toString() {
		return source + super.toString();
	}
	
	@Override
	public String getOpName() {
		return "assignment";
	}
}
