package dk.brics.xact.analysis.xmlgraph;

import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;

import dk.brics.xmlgraph.Node;
import dk.brics.xmlgraph.NodeProcessor;

public abstract class CachedNodeProcessor<T> extends NodeProcessor<T> {
	
	private Map<Node,T> visited = new HashMap<Node,T>();
	private Set<Node> active = new HashSet<Node>();
	
	public abstract T cycle();
	
	@Override
	public T pre(Node n) {
		if (visited.containsKey(n))
			return visited.get(n);
		if (!active.add(n))
			return cycle();
		return null;
	}
	@Override
	public void post(Node n, T t) {
		visited.put(n, t);
		active.remove(n);
	}
}
