package dk.brics.xact.operations;

import java.util.concurrent.ConcurrentHashMap;

import dk.brics.xact.XML;

/**
 * Cache for parsed templates.
 */
public class TemplateCache {

	private static ConcurrentHashMap<Object, XML> cache = new ConcurrentHashMap<Object, XML>();
	
	private TemplateCache() {}
	
	/**
	 * Stores a parsed template in the cache.
	 */
	public static void put(Object key, XML value) {
		cache.put(key, value);
	}
	
	/**
	 * Loads a parsed template from the cache.
	 * Returns null if not found.
	 */
	public static XML get(Object key) {
		return cache.get(key);
	}
	
	/**
	 * Clears the cache.
	 */
	public static void clear() {
		cache.clear();
	}
}
